---
title: CanvasRenderingContext2D.globalCompositeOperation
slug: Web/API/CanvasRenderingContext2D/globalCompositeOperation
tags:
  - API
  - Blending
  - Canvas
  - CanvasRenderingContext2D
  - Compositing
  - Property
  - Reference
---
<div>{{APIRef}}</div>

<p>The <code><strong>CanvasRenderingContext2D</strong></code><strong><code>.globalCompositeOperation</code></strong> property of the Canvas 2D API sets the type of compositing operation to apply when drawing new shapes.</p>

<p>See also <a href="/en-US/docs/Web/API/Canvas_API/Tutorial/Compositing">Compositing and clipping</a> in the <a href="/en-US/docs/Web/API/Canvas_API/Tutorial">Canvas Tutorial</a>.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><em>ctx</em>.globalCompositeOperation = <em>type</em>;</pre>

<p><code>type</code> is a {{jsxref("String")}} identifying which of the compositing or blending mode operations to use.</p>

<h3 id="Types">Types</h3>

<p>{{EmbedLiveSample("Compositing_example", 750, 6900, "" ,"Web/API/Canvas_API/Tutorial/Compositing/Example")}}</p>

<h2 id="Examples">Examples</h2>

<h3 id="Changing_the_composite_operation">Changing the composite operation</h3>

<p>This example uses the <code>globalCompositeOperation</code> property to draw two rectangles that exclude themselves where they overlap.</p>

<h4 id="HTML">HTML</h4>

<pre class="brush: html">&lt;canvas id="canvas"&gt;&lt;/canvas&gt;
</pre>

<h4 id="JavaScript">JavaScript</h4>

<pre class="brush: js; highlight[4]">const canvas = document.getElementById('canvas');
const ctx = canvas.getContext('2d');

ctx.globalCompositeOperation = 'xor';

ctx.fillStyle = 'blue';
ctx.fillRect(10, 10, 100, 100);

ctx.fillStyle = 'red';
ctx.fillRect(50, 50, 100, 100);
</pre>

<h4 id="Result">Result</h4>

<p>{{ EmbedLiveSample('Changing_the_composite_operation', 700, 180) }}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('HTML WHATWG', "scripting.html#dom-context-2d-globalcompositeoperation", "CanvasRenderingContext2D.globalCompositeOperation")}}</td>
   <td>{{Spec2('HTML WHATWG')}}</td>
   <td></td>
  </tr>
  <tr>
   <td>{{SpecName('Compositing')}}</td>
   <td>{{Spec2('Compositing')}}</td>
   <td></td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.CanvasRenderingContext2D.globalCompositeOperation")}}</p>

<h3 id="WebKitBlink-specific_notes">WebKit/Blink-specific notes</h3>

<ul>
 <li>In WebKit- and Blink-based Browsers, a non-standard and deprecated method <code>ctx.setCompositeOperation()</code> is implemented besides this property.</li>
 <li>Support for <code>"plus-darker"</code> and <code>"darker"</code> were removed in Chrome 48. Developers looking for a replacement should use <code>"darken"</code>.</li>
</ul>

<h3 id="Gecko-specific_notes">Gecko-specific notes</h3>

<ul>
 <li>An early Canvas specification draft specified the value <code>"darker"</code>. However, Firefox removed support for <code>"darker"</code> in version 4 ({{bug(571532)}}). See also <a href="http://dropshado.ws/post/77229081704/firefox-doesnt-support-canvas-composite-darker">this blog post</a> that suggests using <code>"difference"</code> as a way to achieve a similar affect to <code>"darker"</code>.</li>
</ul>

<h2 id="See_also">See also</h2>

<ul>
 <li>The interface defining this property: {{domxref("CanvasRenderingContext2D")}}</li>
 <li>{{domxref("CanvasRenderingContext2D.globalAlpha")}}</li>
</ul>
